Change plugins directory through the configuration.yml file
Status: Reopened Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Plugin API Estimated time: 0.00 hour

Target version:    

Description

This patch adds the possibility to change the directory "plugins" of the application through the file configuration.yml.

The patch has been tested with the last Trunk version (15839)

Related issues:

Related to Redmine - Patch #13927: Reduce coupling between plugins and the "p... New

Blocked by Redmine - Patch #26139: Follow Gemfile's plugin loader as #24007 Reopened

Associated revisions

Revision 15963 - 2016-11-18 13:14 - Jean-Philippe Lang

Change plugins directory through the configuration.yml file (#24007).

Patch by Helder Manuel Torres Vieira.

Revision 15964 - 2016-11-18 13:20 - Jean-Philippe Lang

Code cleanup (#24007).

Revision 16654 - 2017-06-10 14:05 - Jean-Philippe Lang

Plugin directory is configurable (#24007).

Patch by Go MAEDA.

Revision 16666 - 2017-06-17 09:31 - Jean-Philippe Lang

Change plugins directory through the configuration.yml file (#24007, #26139).

Patch by Sho HASHIMOTO

Revision 16669 - 2017-06-17 09:50 - Jean-Philippe Lang

Reverts r16666 that prevents Redmine to start.

[!] There was an error parsing `Gemfile`: uninitialized constant Bundler::Dsl::R

edmine. Bundler cannot continue.

Revision 16670 - 2017-06-17 09:57 - Jean-Philippe Lang

Redmine::Plugin.directory is an absolute path (#24007).

Revision 16675 - 2017-06-17 12:40 - Jean-Philippe Lang

Removes plugins_path from configuration file (#24007).

History

#1 - 2016-10-08 10:30 - Jean-Philippe Lang

- Status changed from New to Needs feedback

In the comments, you say that Redmine needs to have write permission on the plugins directory. Why is that? I think it should have read permission

only.

#2 - 2016-10-08 12:36 - Andrey Lobanov (RedSoft)
I agree. Why plugins directory should have write permissions?

#3 - 2016-10-09 11:07 - Jean-Philippe Lang

- Category set to Plugin API

- Status changed from Needs feedback to New

- Assignee set to Jean-Philippe Lang

- Target version set to 3.4.0

#4 - 2016-10-10 15:01 - Helder Manuel Torres Vieira

Hello,

Sorry, it was a mistake, i was talking about read permissions (not write).

Thanks

#5 - 2016-11-18 13:20 - Jean-Philippe Lang

- Status changed from New to Closed

Patch committed, thanks.

#6 - 2017-04-10 15:40 - Go MAEDA

- Status changed from Closed to Reopened

config/routes.rb must be aware of plugins_path setting.

Index: config/routes.rb

===================================================================

--- config/routes.rb    (revision 16528)

+++ config/routes.rb    (working copy)

@@ -374,7 +374,7 @@

   get 'robots.txt', :to => 'welcome#robots'

-  Dir.glob File.expand_path("plugins/*", Rails.root) do |plugin_dir|

+  Dir.glob File.expand_path("#{Redmine::Plugin.directory}/*", Rails.root) do |plugin_dir|

     file = File.join(plugin_dir, "config/routes.rb")

     if File.exists?(file)

       begin

#7 - 2017-04-15 02:12 - Anonymous

I wish that functionality, would be very great for multitenancy environments.

#8 - 2017-06-10 14:05 - Jean-Philippe Lang

- Status changed from Reopened to Closed

Fix committed, thanks.

#9 - 2017-06-12 11:34 - Go MAEDA

- Blocked by Patch #26139: Follow Gemfile's plugin loader as #24007 added

#10 - 2017-06-12 11:35 - Go MAEDA

- Status changed from Closed to Reopened

Reopening this issue because a fix for this feature has been submitted as #26139.

#11 - 2017-06-13 06:36 - Sho HASHIMOTO

Is r16654 correct?

config_plugins_path.diff defines Redmine::Plugin.directory as  "Absolute path to the directory where plugins are stored.".

File.expand_path("#{Redmine::Plugin.directory}/*", Rails.root) maybe returns "#{Rails.root}/#{Redmine::Plugin.directory}/*"

#12 - 2017-06-17 09:59 - Jean-Philippe Lang
Sho HASHIMOTO wrote:

Is r16654 correct?

config_plugins_path.diff defines Redmine::Plugin.directory as  "Absolute path to the directory where plugins are stored.".

File.expand_path("#{Redmine::Plugin.directory}/*", Rails.root) maybe returns "#{Rails.root}/#{Redmine::Plugin.directory}/*"

 No it does not returns that because the first argument is an absolute path. But for clarity, I've removed the second arg that is not used. Thanks for

pointing this out.

#13 - 2017-06-17 12:41 - Jean-Philippe Lang

- Assignee deleted (Jean-Philippe Lang)

- Target version deleted (3.4.0)

The current implementation does not support loading plugin gemfiles (#26139), I've removed the option in the configuration file for 3.4.0

#14 - 2017-06-18 13:56 - Mischa The Evil

- Related to Patch #13927: Reduce coupling between plugins and the "plugins/" directory added

Files

config_plugins_path.diff 3.85 KB 2016-10-05 Helder Manuel Torres Vieira
